from flask import app, request
from flask import Flask
import database_helper
import json


#Lesson 2,
#Subject: Server-side programming
#Date and time: Monday, January 30th 2018. 13:15-15.
#Location: A1 Seminar room,A huset, Campus Valla.
#Author: Sahand Sadjadee


app = Flask(__name__)
app.debug = True


@app.before_request
def before_request():
    database_helper.connect_db()

@app.teardown_request
def teardown_request(exception):
    database_helper.close_db()

@app.route('/')
@app.route('/home')
@app.route('/profile')
def hello_world():
    return 'Welcome to phonebook'


@app.route('/savecontact', methods=['POST'])
def save_contact():

    firstname = request.json['firstname']
    familyname = request.json['familyname']
    phonenumber = request.json['mobile']

    result = database_helper.insert_contact(firstname, familyname, phonenumber)
    if result == True:
        return 'contact added'
    else:
        return 'could not add the contact'


@app.route('/getcontact/<firstname>/<familyname>', methods=['GET'])
def get_contact(firstname = None, familyname = None):
    if firstname != None and familyname != None:
        result = database_helper.get_contact(firstname, familyname)
        if len(result) == 0:
            return 'contact not found'
        else:
            return json.dumps(result)
    else:
        return "Invalid data"


if __name__ == '__main__':
    app.run()
